regina::GluingPermSearcher< 3 > Class Template Reference
Census of Triangulations

A utility class for searching through all possible gluing permutation sets that correspond to a given tetrahedron face pairing. More...

`#include <census/gluingpermsearcher3.h>`

Inheritance diagram for regina::GluingPermSearcher< 3 >:

## Public Types

enum | PurgeFlags { PURGE_NONE = 0, PURGE_NON_MINIMAL = 1, PURGE_NON_PRIME = 2, PURGE_NON_MINIMAL_PRIME = 3, PURGE_NON_MINIMAL_HYP = 9, PURGE_P2_REDUCIBLE = 4 }
| Flags to indicate that our enumeration may (at the discretion of the enumeration algorithm) ignore certain classes of triangulations. More...
typedef void(* | Use) (const GluingPermSearcher< 3 > *, void *)
| A routine that can do arbitrary processing upon a set of gluing permutations. More...

## Public Member Functions

| GluingPermSearcher (const FacetPairing< 3 > *pairing, const FacetPairing< 3 >::IsoList *autos, bool orientableOnly, bool finiteOnly, int whichPurge, GluingPermSearcher< 3 >::Use use, void *useArgs=0)
| Initialises a new search for gluing permutation sets. More...
| GluingPermSearcher (std::istream &in, GluingPermSearcher< 3 >::Use use, void *useArgs=0)
| Initialises a new search manager based on data read from the given input stream. More...
virtual | ~GluingPermSearcher ()
| Destroys this search manager and all supporting data structures. More...
virtual void | runSearch (long maxDepth=-1)
| Generates all possible gluing permutation sets that satisfy the current search criteria. More...
bool | completePermSet () const
| Determines whether this search manager holds a complete gluing permutation set or just a partially completed search state. More...
void | dumpTaggedData (std::ostream &out) const
| Dumps all internal data in a plain text format, along with a marker to signify which precise class the data belongs to. More...
virtual void | dumpData (std::ostream &out) const
| Dumps all internal data in a plain text format to the given output stream. More...
bool | inputError () const
| Was an error found during construction from an input stream? More...
unsigned | size () const
| Returns the total number of simplices under consideration. More...
const FacetPairing< dim > * | facetPairing () const
| Returns the specific pairing of simplex facets that this set of gluing permutations complements. More...
Perm< dim+1 > | gluingPerm (const FacetSpec< dim > &source) const
| Returns the gluing permutation associated with the given simplex facet. More...
Perm< dim+1 > | gluingPerm (unsigned simp, unsigned facet) const
| Returns the gluing permutation associated with the given simplex facet. More...
Triangulation< dim > * | triangulate () const
| Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing. More...

## Static Public Member Functions

static void | findAllPerms (const FacetPairing< 3 > *pairing, const FacetPairing< 3 >::IsoList *autos, bool orientableOnly, bool finiteOnly, int whichPurge, GluingPermSearcher< 3 >::Use use, void *useArgs=0)
| The main entry routine for running a search for all gluing permutation sets that complement a given face pairing. More...
static GluingPermSearcher< 3 > * | bestSearcher (const FacetPairing< 3 > *pairing, const FacetPairing< 3 >::IsoList *autos, bool orientableOnly, bool finiteOnly, int whichPurge, GluingPermSearcher< 3 >::Use use, void *useArgs=0)
| Constructs a search manager of the best possible class for the given search parameters. More...
static GluingPermSearcher< 3 > * | readTaggedData (std::istream &in, GluingPermSearcher< 3 >::Use use, void *useArgs=0)
| Creates a new search manager based on tagged data read from the given input stream. More...

## Static Public Attributes

static const char | dataTag_
| A character used to identify this class when reading and writing tagged data in text format. More...

## Protected Member Functions

bool | isCanonical () const
| Compares the current set of gluing permutations with its preimage under each automorphism of the underlying face pairing, in order to see whether the current set is in canonical form (i.e., is lexicographically smallest). More...
bool | badEdgeLink (const FacetSpec< 3 > &face) const
| Determines whether the permutations already constructed model a triangulation with an edge identified with itself in reverse. More...
bool | lowDegreeEdge (const FacetSpec< 3 > &face, bool testDegree12, bool testDegree3) const
| Determines whether the permutations already constructed model a triangulation with a low degree edge. More...
virtual char | dataTag () const
| Returns the character used to identify this class when storing tagged data in text format. More...
int & | permIndex (const FacetSpec< dim > &source)
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
int & | permIndex (unsigned simp, unsigned facet)
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (const FacetSpec< dim > &source) const
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (unsigned simp, unsigned facet) const
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
int | gluingToIndex (const FacetSpec< dim > &source, const Perm< dim+1 > &gluing) const
| Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
int | gluingToIndex (unsigned simp, unsigned facet, const Perm< dim+1 > &gluing) const
| Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
Perm< dim+1 > | indexToGluing (const FacetSpec< dim > &source, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1. More...
Perm< dim+1 > | indexToGluing (unsigned simp, unsigned facet, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1. More...

## Protected Attributes

const FacetPairing< 3 >::IsoList * | autos_
| The set of isomorphisms that define equivalence of gluing permutation sets. More...
bool | autosNew
| Did we create the isomorphism list autos_ ourselves (in which case we must destroy it also)? More...
bool | orientableOnly_
| Are we only searching for gluing permutations that correspond to orientable triangulations? More...
bool | finiteOnly_
| Are we only searching for gluing permutations that correspond to finite triangulations? More...
int | whichPurge_
| Are there any types of triangulation that we may optionally avoid constructing? This should be a bitwise OR of constants from the PurgeFlags enumeration. More...
GluingPermSearcher< 3 >::Use | use_
| A routine to call each time a gluing permutation set is found during the search. More...
void * | useArgs_
| Additional user-supplied data to be passed as the second argument to the use_ routine. More...
bool | started
| Has the search started yet? This helps distinguish between a new search and the resumption of a partially completed search. More...
int * | orientation
| Keeps track of the orientation of each tetrahedron in the underlying triangulation. More...
FacetSpec< 3 > * | order
| Describes the order in which gluing permutations are assigned to faces. More...
int | orderSize
| The total number of edges in the face pairing graph, i.e., the number of elements of interest in the order[] array. More...
int | orderElt
| Marks which element of order[] we are currently examining at this stage of the search. More...
const FacetPairing< dim > * | pairing_
| The facet pairing that this permutation set complements. More...
int * | permIndices_
| The index into array Perm<dim+1>::Sn_1 describing how each simplex facet is glued to its partner. More...
bool | inputError_
| Has an error occurred during construction from an input stream? More...

## Detailed Description

### template<>
class regina::GluingPermSearcher< 3 >

A utility class for searching through all possible gluing permutation sets that correspond to a given tetrahedron face pairing.

Subclasses of GluingPermSearcher<3> correspond to specialised (and heavily optimised) search algorithms that may be used in sufficiently constrained scenarios. The main class GluingPermSearcher<3> offers a default (but slower) search algorithm that may be used in more general contexts.

The simplest way of performing a search through all possible gluing permutations is by calling the static method findAllPerms(). This will examine the search parameters and ensure that the best possible algorithm is used. For finer control over the program flow, the static method bestSearcher() can be used to create a search manager of the most suitable class and then runSearch() can be called on this object directly. For absolute control, a specific algorithm can be forced by explicitly constructing an object of the corresponding class (and again calling runSearch() on that object directly).

Note that this class derives from GluingPerms<3>. The search will involve building and repeatedly modifying the inherited GluingPerms<3> data in-place.

Python:
  Only the PurgeFlags enumeration from this class is present, and the PurgeFlags constants are also made directly available through the regina namespace. Therefore there is no need to explicitly access the class GluingPermSearcher<3> through Python.

## Member Typedef Documentation

## Use

typedef void(* regina::GluingPermSearcher< 3 >::Use) (const GluingPermSearcher< 3 > *, void *)

A routine that can do arbitrary processing upon a set of gluing permutations.

Such routines are used to process permutation sets that are found when running census-building routines such as findAllPerms().

The first parameter passed will be a set of gluing permutations (as this class derives from GluingPerms<3>). This set of gluing permutations must not be deallocated by this routine, since it may be used again later by the caller. The second parameter may contain arbitrary data; typically this will be the data passed to the relevant search routine, such as findAllPerms() or the GluingPermSearcher class constructor.

Note that the first parameter passed might be `null` to signal that gluing permutation generation has finished.

## Member Enumeration Documentation

## PurgeFlags

enum regina::GluingPermSearcher< 3 >::PurgeFlags

Flags to indicate that our enumeration may (at the discretion of the enumeration algorithm) ignore certain classes of triangulations.

These flags can be combined using bitwise OR.

See the GluingPermSearcher<3> constructor documentation for further details on how these flags are used.

Python:
  For convenience, these constants are also made available directly in Python's regina namespace.

Enumerator
PURGE_NONE | Indicates that no triangulations should be ignored.
PURGE_NON_MINIMAL | Indicates that non-minimal triangulations may be ignored.
PURGE_NON_PRIME | Indicates that any triangulation that is not prime (i.e., can be written as a non-trivial connected sum) and any bounded triangulation that is reducible over a disc may be ignored.
PURGE_NON_MINIMAL_PRIME | Indicates that any triangulation that is not prime (i.e., can be written as a non-trivial connected sum), any bounded triangulation that is reducible over a disc and any triangulation that is non-minimal may be ignored. Note that this is simply a combination of the constants PURGE_NON_MINIMAL and PURGE_NON_PRIME.
PURGE_NON_MINIMAL_HYP | Indicates that any triangulation that is not a minimal ideal triangulation of a cusped finite-volume hyperbolic 3-manifold may be ignored.
PURGE_P2_REDUCIBLE | Indicates that any triangulation containing an embedded two-sided projective plane may be ignored.

## Constructor & Destructor Documentation

## GluingPermSearcher() [1/2]

regina::GluingPermSearcher< 3 >::GluingPermSearcher | ( | const FacetPairing< 3 > * | pairing,
|  | const FacetPairing< 3 >::IsoList * | autos,
|  | bool | orientableOnly,
|  | bool | finiteOnly,
|  | int | whichPurge,
|  | GluingPermSearcher< 3 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

Initialises a new search for gluing permutation sets.

The search is started by calling runSearch(). Note that the static method findAllPerms() handles both construction and searching, and is the preferred entry point for end users.

The arguments to this constructor describe the search parameters in detail, as well as what should be done with each gluing permutation set that is found.

Parameter whichPurge may be used to avoid constructing permutation sets that correspond to triangulations satisfying certain constraints (such as non-minimality). The use of this parameter, combined with parameters orientableOnly and finiteOnly, can significantly speed up the permutation set generation. For some combinations of these parameters entirely different algorithms are used.

Note that not all permutation sets described by parameter whichPurge will be avoided (i.e., you may get gluing permutation sets that you did not want). It is guaranteed however that every permutation set whose corresonding triangulation does not satisfy the whichPurge constraints will be generated.

Similarly, even if finiteOnly is set to `true`, some non-finite triangulations might still slip through the net (since the full vertex links are not always constructed). However, like whichPurge, setting finiteOnly to `true` allow the census algorithm to take shortcuts and therefore run faster. The resulting triangulations may be tested for finiteness (and other properties) by calling triangulate().

Precondition
  The given face pairing is connected, i.e., it is possible to reach any tetrahedron from any other tetrahedron via a series of matched face pairs.
  The given face pairing is in canonical form as described by FacetPairing<3>::isCanonical(). Note that all face pairings constructed by FacetPairing<3>::findAllPairings() are of this form.

Parameters

  pairing | the specific pairing of tetrahedron faces that the generated permutation sets will complement.

  autos

  the collection of isomorphisms that define equivalence of permutation sets. These are used by runSearch(), which produces each permutation set precisely once up to equivalence. These isomorphisms must all be automorphisms of the given face pairing, and will generally be the set of all such automorphisms. This parameter may be 0, in which case the set of all automorphisms of the given face pairing will be generated and used.

  orientableOnly | `true` if only gluing permutations corresponding to orientable triangulations should be generated, or `false` if no such restriction should be imposed.
  finiteOnly | `true` if only gluing permutations corresponding to finite triangulations are required, or `false` if there is no such requirement. Note that regardless of this value, some non-finite triangulations might still be produced; see the notes above for details.

  whichPurge

  specifies which permutation sets we may avoid constructing (see the function notes above for details). This should be a bitwise OR of constants from the PurgeFlags enumeration, or 0 if we should simply generate every possible permutation set. If a variety of purge constants are bitwise ORed together, a permutation set whose triangulation satisfies any of these constraints may be avoided. Note that not all such permutation sets will be avoided, but enough are avoided that the performance increase is noticeable.

  use | the function to call upon each permutation set that is found. The first parameter passed to this function will be a gluing permutation set. The second parameter will be parameter useArgs as was passed to this routine.
  useArgs | the pointer to pass as the final parameter for the function use which will be called upon each permutation set found.

## GluingPermSearcher() [2/2]

regina::GluingPermSearcher< 3 >::GluingPermSearcher | ( | std::istream & | in,
|  | GluingPermSearcher< 3 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

Initialises a new search manager based on data read from the given input stream.

This may be a new search or a partially completed search.

This routine reads data in the format written by dumpData(). If you wish to read data whose precise class is unknown, consider using dumpTaggedData() and readTaggedData() instead.

If the data found in the input stream is invalid or incorrectly formatted, the routine inputError() will return `true` but the contents of this object will be otherwise undefined.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  in | the input stream from which to read.
  use | as for the main GluingPermSearcher<3> constructor.
  useArgs | as for the main GluingPermSearcher<3> constructor.

## ~GluingPermSearcher()

virtual regina::GluingPermSearcher< 3 >::~GluingPermSearcher | ( |  | ) |

virtual

Destroys this search manager and all supporting data structures.

## Member Function Documentation

## badEdgeLink()

bool regina::GluingPermSearcher< 3 >::badEdgeLink | ( | const FacetSpec< 3 > & | face | ) | const

protected

Determines whether the permutations already constructed model a triangulation with an edge identified with itself in reverse.

Note that such edges can only occur in non-orientable triangulations.

Tests that do not refer to the gluing permutation for the given face will not be run.

This routine is not fussy about the order in which gluing permutations are selected, as long as permutations not yet selected have the corresponding element of permIndices[] set to -1.

If finiteOnly_ is `true` in the search criteria, additional tests will be run that can eliminate triangulations with non-orientable vertex links. Although these tests are not searching for bad edge links per se, they can be performed within this routine with very little additional work needing to be done.

Parameters

  face | the specific tetrahedron face upon which tests will be based.

Returns
  `true` if the permutations under construction will lead to an edge identified with itself in reverse, or `false` if no such edge is found.

## bestSearcher()

static GluingPermSearcher<3>* regina::GluingPermSearcher< 3 >::bestSearcher | ( | const FacetPairing< 3 > * | pairing,
|  | const FacetPairing< 3 >::IsoList * | autos,
|  | bool | orientableOnly,
|  | bool | finiteOnly,
|  | int | whichPurge,
|  | GluingPermSearcher< 3 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

static

Constructs a search manager of the best possible class for the given search parameters.

Different subclasses of GluingPermSearcher<3> provide optimised search algorithms for different types of search.

Calling this routine and then calling runSearch() on the result has the same effect as the all-in-one routine findAllPerms(). Unless you have specialised requirements (such as partial searching), you are probably better calling findAllPerms() instead.

The resulting object is newly created, and must be destroyed by the caller of this routine.

See the GluingPermSearcher<3> constructor for documentation on the arguments to this routine.

Precondition
  The given face pairing is connected, i.e., it is possible to reach any tetrahedron from any other tetrahedron via a series of matched face pairs.
  The given face pairing is in canonical form as described by FacetPairing<3>::isCanonical(). Note that all face pairings constructed by FacetPairing<3>::findAllPairings() are of this form.

Returns
  the newly created search manager.

## completePermSet()

bool regina::GluingPermSearcher< 3 >::completePermSet | ( |  | ) | const

inline

Determines whether this search manager holds a complete gluing permutation set or just a partially completed search state.

This may assist the use_ routine when running partial depth-based searches. See runSearch() for further details.

Returns
  `true` if a complete gluing permutation set is held, or `false` otherwise.

## dataTag()

char regina::GluingPermSearcher< 3 >::dataTag | ( |  | ) | const

inline protected virtual

Returns the character used to identify this class when storing tagged data in text format.

Returns
  the class tag.

Reimplemented in regina::HyperbolicMinSearcher, regina::ClosedPrimeMinSearcher, regina::CompactSearcher, and regina::EulerSearcher.

## dumpData()

virtual void regina::GluingPermSearcher< 3 >::dumpData | ( | std::ostream & | out | ) | const

virtual

Dumps all internal data in a plain text format to the given output stream.

This object can be recreated from this text data by calling the input stream constructor for this class.

This routine may be useful for transferring objects from one processor to another.

Note that subclass data is written after superclass data, so it is safe to dump data from a subclass and then recreate a new superclass object from that data (though subclass-specific information will of course be lost).

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  out | the output stream to which the data should be written.

Reimplemented from regina::GluingPerms< 3 >.

Reimplemented in regina::HyperbolicMinSearcher, regina::ClosedPrimeMinSearcher, regina::CompactSearcher, and regina::EulerSearcher.

## dumpTaggedData()

void regina::GluingPermSearcher< 3 >::dumpTaggedData | ( | std::ostream & | out | ) | const

Dumps all internal data in a plain text format, along with a marker to signify which precise class the data belongs to.

This routine can be used with readTaggedData() to transport objects from place to place whose precise class is unknown.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  out | the output stream to which the data should be written.

## facetPairing()

const FacetPairing< dim > * regina::GluingPerms< dim >::facetPairing | ( |  | ) | const

inline inherited

Returns the specific pairing of simplex facets that this set of gluing permutations complements.

Returns
  the corresponding simplex facet pairing.

## findAllPerms()

static void regina::GluingPermSearcher< 3 >::findAllPerms | ( | const FacetPairing< 3 > * | pairing,
|  | const FacetPairing< 3 >::IsoList * | autos,
|  | bool | orientableOnly,
|  | bool | finiteOnly,
|  | int | whichPurge,
|  | GluingPermSearcher< 3 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

static

The main entry routine for running a search for all gluing permutation sets that complement a given face pairing.

This routine examines the search parameters, chooses the best possible search algorithm, constructs an object of the corresponding subclass of GluingPermSearcher<3> and then calls runSearch().

See the GluingPermSearcher<3> constructor for documentation on the arguments to this routine. See the runSearch() method for documentation on how the search runs and returns its results.

Precondition
  The given face pairing is connected, i.e., it is possible to reach any tetrahedron from any other tetrahedron via a series of matched face pairs.
  The given face pairing is in canonical form as described by FacetPairing<3>::isCanonical(). Note that all face pairings constructed by FacetPairing<3>::findAllPairings() are of this form.

## gluingPerm() [1/2]

Perm< dim+1 > regina::GluingPerms< dim >::gluingPerm | ( | const FacetSpec< dim > & | source | ) | const

inline inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine facetPairing()).
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  the associated gluing permutation.

## gluingPerm() [2/2]

Perm< dim+1 > regina::GluingPerms< dim >::gluingPerm | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

inline inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine facetPairing()).

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  the associated gluing permutation.

## gluingToIndex() [1/2]

int regina::GluingPerms< dim >::gluingToIndex | ( | const FacetSpec< dim > & | source,
|  | const Perm< dim+1 > & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm<dim+1>::Sn_1 that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  source | the simplex facet under investigation.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm<dim+1>::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

## gluingToIndex() [2/2]

int regina::GluingPerms< dim >::gluingToIndex | ( | unsigned | simp,
|  | unsigned | facet,
|  | const Perm< dim+1 > & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm<dim+1>::Sn_1 that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm<dim+1>::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

## indexToGluing() [1/2]

Perm< dim+1 > regina::GluingPerms< dim >::indexToGluing | ( | const FacetSpec< dim > & | source,
|  | int | index
| ) |  | const

inline protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1.

This index into Perm<dim+1>::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  source | the simplex facet under investigation.
  index | an index into Perm<dim+1>::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm<dim+1>::Sn_1.

## indexToGluing() [2/2]

Perm< dim+1 > regina::GluingPerms< dim >::indexToGluing | ( | unsigned | simp,
|  | unsigned | facet,
|  | int | index
| ) |  | const

inline protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1.

This index into Perm<dim+1>::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  index | an index into Perm<dim+1>::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm<dim+1>::Sn_1.

## inputError()

bool regina::GluingPerms< dim >::inputError | ( |  | ) | const

inline inherited

Was an error found during construction from an input stream?

This routine returns `true` if an input stream constructor was used to create this object but the data in the input stream was invalid or incorrectly formatted.

If a different constructor was called (i.e., no input stream was used), then this routine will always return `false`.

Returns
  `true` if an error occurred during construction from an input stream, or `false` otherwise.

## isCanonical()

bool regina::GluingPermSearcher< 3 >::isCanonical | ( |  | ) | const

protected

Compares the current set of gluing permutations with its preimage under each automorphism of the underlying face pairing, in order to see whether the current set is in canonical form (i.e., is lexicographically smallest).

Returns
  `true` if the current set is in canonical form, or `false` otherwise.

## lowDegreeEdge()

bool regina::GluingPermSearcher< 3 >::lowDegreeEdge | ( | const FacetSpec< 3 > & | face,
|  | bool | testDegree12,
|  | bool | testDegree3
| ) |  | const

protected

Determines whether the permutations already constructed model a triangulation with a low degree edge.

Precisely which types of low degree edges are identified must be specified through parameters testDegree12 and testDegree3.

Tests that do not refer to the gluing permutation for the given face will not be run.

This routine is not fussy about the order in which gluing permutations are selected, as long as permutations not yet selected have the corresponding element of permIndices[] set to -1.

Parameters

  face | the specific tetrahedron face upon which tests will be based.
  testDegree12 | `true` if we should test for non-boundary edges of degree 1 or 2.
  testDegree3 | `true` if we should test for non-boundary edges of degree 3 involving three distinct tetrahedra.

Returns
  `true` if the permutations under construction will lead to a low-degree edge as specified by parameters testDegree12 and testDegree3, or `false` if no such edge is found.

## permIndex() [1/4]

int & regina::GluingPerms< dim >::permIndex | ( | const FacetSpec< dim > & | source | ) |

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

## permIndex() [2/4]

int & regina::GluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  |

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

## permIndex() [3/4]

const int & regina::GluingPerms< dim >::permIndex | ( | const FacetSpec< dim > & | source | ) | const

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

## permIndex() [4/4]

const int & regina::GluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

## readTaggedData()

static GluingPermSearcher<3>* regina::GluingPermSearcher< 3 >::readTaggedData | ( | std::istream & | in,
|  | GluingPermSearcher< 3 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

static

Creates a new search manager based on tagged data read from the given input stream.

This may be a new search or a partially completed search.

The tagged data should be in the format written by dumpTaggedData(). The precise class of the search manager will be determined from the tagged data, and does not need to be known in advance. This is in contrast to dumpData() and the input stream constructors, where the class of the data being read must be known at compile time.

If the data found in the input stream is invalid or incorrectly formatted, a null pointer will be returned. Otherwise a newly constructed search manager will be returned, and it is the responsibility of the caller of this routine to destroy it after use.

The arguments use and useArgs are the same as for the GluingPermSearcher<3> constructor.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  in | the input stream from which to read.

## runSearch()

virtual void regina::GluingPermSearcher< 3 >::runSearch | ( | long | maxDepth = `-1` | ) |

virtual

Generates all possible gluing permutation sets that satisfy the current search criteria.

The search criteria are specified in the class constructor, or through the static method findAllPerms().

Each set of gluing permutations will be produced precisely once up to equivalence, where equivalence is defined by the given set of automorphisms of the given face pairing.

For each permutation set that is generated, routine use_ (as passed to the class constructor) will be called with that permutation set as an argument.

Once the generation of permutation sets has finished, routine use_ will be called once more, this time with `null` as its first (permutation set) argument.

Subclasses corresponding to more specialised search criteria should override this routine to use a better optimised algorithm where possible.

It is possible to run only a partial search, branching to a given depth but no further. In this case, rather than producing complete gluing permutation sets, the search will produce a series of partially-complete GluingPermSearcher<3> objects. These partial searches may then be restarted by calling runSearch() once more (usually after being frozen or passed on to a different processor). If necessary, the use_ routine may call completePermSet() to distinguish between a complete set of gluing permutations and a partial search state.

Note that a restarted search will never drop below its initial depth. That is, calling runSearch() with a fixed depth can be used to subdivide the overall search space into many branches, and then calling runSearch() on each resulting partial search will complete each of these branches without overlap.

Todo:
  Feature: Allow cancellation of permutation set generation.

Parameters

  maxDepth | the depth of the partial search to run, or a negative number if a full search should be run (the default).

Reimplemented in regina::HyperbolicMinSearcher, regina::ClosedPrimeMinSearcher, regina::CompactSearcher, and regina::EulerSearcher.

## size()

unsigned regina::GluingPerms< dim >::size | ( |  | ) | const

inline inherited

Returns the total number of simplices under consideration.

Returns
  the number of simplices under consideration.

## triangulate()

Triangulation<dim>* regina::GluingPerms< dim >::triangulate | ( |  | ) | const

inherited

Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing.

Each matched pair of facets and their associated permutations will be realised as two simplex facets in the triangulation glued together with the corresponding gluing permutation. Each unmatched facet will be realised as a boundary facet in the triangulation.

It is the responsibility of the caller of this routine to delete this triangulation once it is no longer required.

Returns
  a newly created triangulation modelled by this structure.

## Member Data Documentation

## autos_

const FacetPairing<3>::IsoList* regina::GluingPermSearcher< 3 >::autos_

protected

The set of isomorphisms that define equivalence of gluing permutation sets.

Generally this is the set of all automorphisms of the underlying face pairing.

## autosNew

bool regina::GluingPermSearcher< 3 >::autosNew

protected

Did we create the isomorphism list autos_ ourselves (in which case we must destroy it also)?

## dataTag_

const char regina::GluingPermSearcher< 3 >::dataTag_

static

A character used to identify this class when reading and writing tagged data in text format.

## finiteOnly_

bool regina::GluingPermSearcher< 3 >::finiteOnly_

protected

Are we only searching for gluing permutations that correspond to finite triangulations?

## inputError_

bool regina::GluingPerms< dim >::inputError_

protected inherited

Has an error occurred during construction from an input stream?

## order

FacetSpec<3>* regina::GluingPermSearcher< 3 >::order

protected

Describes the order in which gluing permutations are assigned to faces.

Specifically, this order is order[0], order[1], ..., order[orderSize-1].

Note that each element of this array corresponds to a single edge of the underlying face pairing graph, which in turn represents a tetrahedron face and its image under the given face pairing.

The specific tetrahedron face stored in this array for each edge of the underlying face pairing graph will be the smaller of the two identified tetrahedron faces (unless otherwise specified for a particular edge type; see ClosedPrimeMinSearcher for examples).

## orderElt

int regina::GluingPermSearcher< 3 >::orderElt

protected

Marks which element of order[] we are currently examining at this stage of the search.

## orderSize

int regina::GluingPermSearcher< 3 >::orderSize

protected

The total number of edges in the face pairing graph, i.e., the number of elements of interest in the order[] array.

## orientableOnly_

bool regina::GluingPermSearcher< 3 >::orientableOnly_

protected

Are we only searching for gluing permutations that correspond to orientable triangulations?

## orientation

int* regina::GluingPermSearcher< 3 >::orientation

protected

Keeps track of the orientation of each tetrahedron in the underlying triangulation.

Orientation is positive/negative, or 0 if unknown. Note that in some algorithms the orientation is simply +/-1, and in some algorithms the orientation counts forwards or backwards from 0 according to how many times the orientation has been set or verified.

## pairing_

const FacetPairing<dim>* regina::GluingPerms< dim >::pairing_

protected inherited

The facet pairing that this permutation set complements.

This is guaranteed to be the minimal representative of its facet pairing isomorphism class.

## permIndices_

int* regina::GluingPerms< dim >::permIndices_

protected inherited

The index into array Perm<dim+1>::Sn_1 describing how each simplex facet is glued to its partner.

Note that this is not a gluing permutation as such but rather a permutation of 0,...,dim-1 only (see the routines gluingToIndex() and indexToGluing() for conversions). If a permutation has not yet been selected (e.g., if this permutation set is still under construction) then this index is -1.

## started

bool regina::GluingPermSearcher< 3 >::started

protected

Has the search started yet? This helps distinguish between a new search and the resumption of a partially completed search.

## use_

GluingPermSearcher<3>::Use regina::GluingPermSearcher< 3 >::use_

protected

A routine to call each time a gluing permutation set is found during the search.

## useArgs_

void* regina::GluingPermSearcher< 3 >::useArgs_

protected

Additional user-supplied data to be passed as the second argument to the use_ routine.

## whichPurge_

int regina::GluingPermSearcher< 3 >::whichPurge_

protected

Are there any types of triangulation that we may optionally avoid constructing? This should be a bitwise OR of constants from the PurgeFlags enumeration.

See the constructor documentation for further details on this search parameter.

The documentation for this class was generated from the following file:

- census/gluingpermsearcher3.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).